#!/usr/bin/env python

"""
cdrdao2id3 Version %(__version__)
Frank Meurer <meurer@STOP-UCE.gmx.de>
"""

# todo:
# - use filter method (see below)

__version__ = '0.0.1'
import sys
import glob
import regex
import regsub
import string
import os

# define regex's
regex_trackaudio = regex.compile('TRACK AUDIO')
regex_title = regex.compile('TITLE ')
regex_performer = regex.compile('PERFORMER ')
regex_name = regex.compile('"[^"]*"')

def append_id3(cd_title, track_performer, track_title, filename):
    #print 'id3 -A "%s" -a "%s" -t "%s" "%s"' % (cd_title, track_performer, track_title, filename)
    os.system('id3 -A "%s" -a "%s" -t "%s" "%s" >/dev/null 2>&1' % (cd_title, track_performer, track_title, filename))
    pass

def my_exit(ret):
    sys.stdin.readlines()
    sys.exit(ret)

def get_name(line):
    start = regex_name.search(line)
    return line[start+1:start+regex_name.match(line[start:])-1]

def main():
    # we don't want to run with root privileges
    if os.getuid()==0 or os.geteuid()==0:
        print "error: won't run with root privileges"
        my_exit(1)

    # we don't want to run with setuid bit set
    if os.getuid()!=os.geteuid():
        print "error: won't run with setuid bit set"
        my_exit(1)

    # we don't want to run with setgid bit set
    if os.getgid()!=os.getegid():
        print "error: won't run with setgid bit set"
        my_exit(1)

    # sometimes we need some debugging
    #sys.stdout = open('/tmp/stdout', 'w')
    #sys.stderr = open('/tmp/stderr', 'w')

    toc_file = sys.stdin

    # get the CD title from the first TITLE definition
    got_cd_title = 0
    while not got_cd_title:
        line = toc_file.readline()
        if not line: my_exit(1)
        if not got_cd_title and regex_title.search(line) <> -1:
            cd_title = get_name(line)
            got_cd_title = 1

    track_no = 1
    # read audio.toc from stdin
    # iterate through all .mp3 files
    files = glob.glob('*.mp3')
    files.sort()
    for oldname in files:
        got_track_title = 0
        got_track_performer = 0

        line = toc_file.readline()
        while regex_trackaudio.search(line) == -1:
            line = toc_file.readline()
        while not got_track_title or not got_track_performer:
            line = toc_file.readline()
            if not line: my_exit(1)

            if not got_track_title and regex_title.search(line) <> -1:
                track_title = get_name(line)
                got_track_title = 1

            if not got_track_performer and regex_performer.search(line) <> -1:
                track_performer = get_name(line)
                got_track_performer = 1

        stripped_performer = regsub.gsub('[^A-Za-z0-9_+.,-]', '', track_performer)
        stripped_title = regsub.gsub('[^A-Za-z0-9_+.,-]', '', track_title)
        # filename = "%02d%s-%s.mp3" % (track_no, stripped_performer, stripped_title)
        filename = "%02d%s.mp3" % (track_no, stripped_title)
        print oldname,filename
        os.rename(oldname,filename)
        append_id3(cd_title, track_performer, track_title, filename)
        track_no = track_no + 1

    my_exit(0)

if __name__ == '__main__':
    main()

