#!/usr/bin/env python
"""
cdrdao2wav Version %(__version__)
Frank Meurer <meurer@STOP-UCE.gmx.de>
"""
# todo:
# - use filter method (see below)

__version__ = '0.0.2'
import sys
import regex
import string
import os

def my_exit(ret):
    sys.stdin.readlines()
    sys.exit(ret)

def msf2frame(msf):
    if msf=="": return -1
    if msf==0: return 0
    if msf=="0": return 0
    #print "->",msf[6:8],float(msf[6:8])/75
    #print "->",msf[0:2]
    return int(msf[0:2])*4500+int(msf[3:5])*75+int(msf[6:8])

def msf2float(msf):
    if msf=="": return -1
    if msf=="0": return 0
    if msf==0: return 0
    #print "->",msf[6:8],float(msf[6:8])/75
    #print "->",msf[0:2]
    return int(msf[0:2])*60+int(msf[3:5])+float(float(msf[6:8])/75)

def slice_audio(command):
    print command
    os.system(command)

def main():
    # we don't want to run with root privileges
    if os.getuid()==0 or os.geteuid()==0:
        print "error: won't run with root privileges"
        my_exit(1)
    # we don't want to run with setgid bit set
    if os.getuid()!=os.geteuid():
        print "error: won't run with setgid bit set"
        my_exit(1)
    # sometimes we need some debugging
    #sys.stdout = open('/tmp/stdout', 'w')
    #sys.stderr = open('/tmp/stderr', 'w')

    # define regex's
    regex_trackaudio = regex.compile('TRACK AUDIO')
    regex_file = regex.compile('FILE ')
    regex_filename = regex.compile('"[^"]*"')
    regex_nospace = regex.compile('[ ]*')
    regex_start = regex.compile('START ')
    regex_msf = regex.compile('[0-9:]+')
    regex_msf_sep = regex.compile(':')

    toc_file = sys.stdin
    #CMD_1 = "dd if='%s' bs=2352 skip=%d | sox -t cdr - -t wav audio_%02d.wav"
    CMD_1 = "cdr2wav %s audio_%02d.wav %d"
    #CMD_2 = "dd if='%s' bs=2352 skip=%d count=%d | sox -t cdr - -t wav audio_%02d.wav"
    CMD_2 = "cdr2wav %s audio_%02d.wav %d %d"

    # read audio.toc in a loop from stdin until end
    lastname = ''
    start = len = lastgap = 0
    filecount = 1
    while 1:
        line = toc_file.readline()
        if not line: break

        if regex_file.search(line) <> -1:
            if lastname<>'':
                start = start + lastgap
                if len==-1:
                    slice_audio( CMD_1 % (lastname,filecount,start))
                else:
                    len = len - lastgap
                    slice_audio( CMD_2 % (lastname,filecount,start,len))
                lastgap = 0
                filecount = filecount + 1
            name_start = regex_filename.search(line)
            name_len = regex_filename.match(line[name_start:])
            lastname = line[name_start+1:name_start+name_len-1]
            times = line[name_start+name_len+1:]
            start_start = regex_msf.search(times)
            start_len = regex_msf.match(times[start_start:])
            start = msf2frame(times[start_start:start_start+start_len])
            len = msf2frame(times[start_start+start_len+1:])

        if regex_start.search(line) <> -1:
            gap_start = regex_msf.search(line)
            gap_len = regex_msf.match(line[gap_start:])
            lastgap = msf2frame(line[gap_start:gap_start+gap_len])
            #lastgap=0
            #print start,len,lastgap
    start = start + lastgap
    if len==-1:
        slice_audio( CMD_1 % (lastname,filecount,start))
    else:
        len = len - lastgap
        slice_audio( CMD_2 % (lastname,filecount,start,len))

if __name__ == '__main__':
    main()
