;
; daemonize-linkwld.asm
; run a program (commonly a shell script) as daemon
; this asm-Version must be processed by "nasm -f elf" and linked with ld
; Frank Bergmann www.tuxad.com, 11/2007
; 

section .text    ;section declaration

                 ;we must export the entry point to the ELF linker or
global _start    ;loader. They conventionally recognize _start as their
                 ;entry point. Use ld -e foo to override the default.

_start:

        mov     eax,2   ;fork()
        int     0x80
        or      eax,eax
        jz      child
        inc     eax
        jz      error
        mov     ebx,0   ;father: return 0
        mov     eax,1   ;_exit()
        int     0x80
error   mov     ebx,1   ;error on fork: return 1
        mov     eax,1   ;_exit()
        int     0x80

child   mov     eax,66  ;setsid()
        int     0x80

        mov     ebx,0
        mov     eax,60  ;umask()
        int     0x80

        mov     ebx,rdirstr
        mov     eax,12  ;chdir()
        int     0x80

        mov     ebx,0
        mov     eax,6   ;close()
        int     0x80

        mov     ebx,1
        mov     eax,6   ;close()
        int     0x80

        mov     ebx,2
        mov     eax,6   ;close()
        int     0x80

        lea     ecx,[esp+8]
        mov     ebx,[ecx]
        mov     edx,0
        mov     eax,11
        int     0x80

        mov ebx,2       ;error on exec: return 2
        mov     eax,1   ;_exit()
        int     0x80


section .data    ;section declaration

rdirstr     db      "/",0
