;
; daemonize.asm
; run a program (commonly a shell script) as daemon
; this asm-Version must be processed by "nasm -f bin" to produce a executable
; Frank Bergmann www.tuxad.com, 11/2007
; 

BITS 32

              org     0x08048000
              ;org     0x0804802C

ehdr:                                                 ; Elf32_Ehdr
              db      0x7F, "ELF", 1, 1, 1            ;   e_ident
      times 9 db      0
              dw      2                               ;   e_type
              dw      3                               ;   e_machine
              dd      1                               ;   e_version
              dd      _start                          ;   e_entry
              dd      phdr - $$                       ;   e_phoff
              dd      0                               ;   e_shoff
              dd      0                               ;   e_flags
              dw      ehdrsize                        ;   e_ehsize
              dw      phdrsize                        ;   e_phentsize
              dw      2                               ;   e_phnum
              dw      40                              ;   e_shentsize, 40 for 32Bit
              dw      0                               ;   e_shnum
              dw      0                               ;   e_shstrndx

ehdrsize      equ     $ - ehdr

phdr:                                                 ; Elf32_Phdr
              dd      1                               ;   p_type
              dd      0                               ;   p_offset
              dd      $$                              ;   p_vaddr
              dd      $$                              ;   p_paddr
              dd      filesize                        ;   p_filesz
              dd      filesize                        ;   p_memsz
              dd      5                               ;   p_flags
              dd      0x1000                          ;   p_align

phdrsize      equ     $ - phdr

_start:

        mov     eax,2   ;fork()
        int     0x80
        or      eax,eax
        jz      child
        inc     eax
        jz      error
        mov     ebx,0   ;father: return 0
        mov     eax,1   ;_exit()
        int     0x80
error   mov     ebx,1   ;error on fork: return 1
        mov     eax,1   ;_exit()
        int     0x80

child   mov     eax,66  ;setsid()
        int     0x80

        mov     ebx,0
        mov     eax,60  ;umask()
        int     0x80

        mov     ebx,rdirstr
        mov     eax,12  ;chdir()
        int     0x80

        mov     ebx,0
        mov     eax,6   ;close()
        int     0x80

        mov     ebx,1
        mov     eax,6   ;close()
        int     0x80

        mov     ebx,2
        mov     eax,6   ;close()
        int     0x80

        lea     ecx,[esp+8]
        mov     ebx,[ecx]
        mov     edx,0
        mov     eax,11
        int     0x80

        mov ebx,2       ;error on exec: return 2
        mov     eax,1   ;_exit()
        int     0x80

rdirstr     db      "/",0

filesize      equ     $ - $$
