/*
 * ip_dotted2long.c
 * converts list of dotted decimal ip addresses to decimal longs
 * from stdin to stdout
 * compile with:
 * diet -Os gcc -march=i586 -Os -nostdinc -I/usr/lib/dietlibc/include -Wall ...
 * Frank Bergmann <something@tuxad.com>
 */
#include <stdio.h>
#include <stdlib.h>

int getnum() {
  register int c;

  c=getchar();
  if(c==EOF) { /* file must not end with a non-cipher */
    exit(0);
  }
  c=c-'0';
  if((c<0) || (c>9)) {
    return -1;
  }
  return c;
}

void putlong(unsigned long ip) {
  register unsigned long i,d;
  register int c,o;

  i=ip;
  o=0;
  for(d=1000000000;d>1;d/=10) {
    c=i/d;
    if((c>0)||(o)) {
      putchar(c+'0');
      i=i-(c*d);
      o=1;
    }
  }
  putchar(i+'0');
  putchar('\n');
}

int get_octet() {
  register int num,value;

  value=getnum();
  if(value==-1) {
    return -1;
  }
  num=getnum();
  if(num==-1) {
    return value;
  }
  value=(value*10)+num;
  num=getnum();
  if(num==-1) {
    return value;
  }
  value=(value*10)+num;
  num=getchar(); /* read dot (or other char) */
  return value;
}

int main() {
  register int octet;
  register unsigned long ip;

  while(1) {
    ip=(long) get_octet(); /* 1 */
    if(ip!=-1) {
      octet=get_octet(); /* 2 */
      if(octet!=-1) {
        ip=(ip*256)+octet;
        octet=get_octet(); /* 3 */
        if(octet!=-1) {
          ip=(ip*256)+octet;
          octet=get_octet(); /* 4 */
          if(octet!=-1) {
            ip=(ip*256)+octet;
            putlong(ip);
          }
        }
      }
    }
  }
  return(0);
}
