/*
 * ip_long2dotted.c
 * converts list of long decimal ip addresses to dotted decimal
 * from stdin to stdout
 * compile with:
 * diet -Os gcc -march=i586 -Os -nostdinc -I/usr/lib/dietlibc/include -Wall ...
 * Frank Bergmann <something@tuxad.com>
 */
#include <stdio.h>
#include <stdlib.h>

int getnum() {
  register int c;

  c=getchar();
  if(c==EOF) { /* file must not end with a non-cipher */
    exit(0);
  }
  c=c-'0';
  if((c<0) || (c>9)) {
    return -1;
  }
  return c;
}

void putint(int octet) {
  register int i,c,o;

  i=octet;
  o=0;
  c=i/100;
  if(c>0) {
    putchar(c+'0');
    i=i-(c*100);
    o=1;
  }
  c=i/10;
  if((c>0)||(o)) {
    putchar(c+'0');
    i=i-(c*10);
  }
  putchar(i+'0');
}

void print_ip(unsigned long i) {
  register unsigned long ip;
  register unsigned int div;

  ip=i;
  div=ip/16777216;
  putint(div);
  ip=ip-(div*16777216);
  div=ip/65536;
  putchar('.');
  putint(div);
  ip=ip-(div*65536);
  div=ip/256;
  putchar('.');
  putint(div);
  ip=ip-(div*256);
  putchar('.');
  putint((int)ip);
  putchar('\n');
}

int main() {
  register int num;
  register unsigned long ip;

  while(1) {
    /* 1 */
    ip=(long) getnum();
    if(ip!=-1) {
      /* 2-9 */
      num=getnum();
      while(num!=-1) {
        ip=(ip*10)+num;
        num=getnum();
      }
      print_ip(ip);
    }
  }
  return(0);
}
