/*
 * raw2352tocdr2352.c v.0.0.2
 * swap bytes on 16-Bit audio input stream/ convert CDR to
 * RAW (aka WAVE w/o wave-header) audio and vice versa
 * compile with i.e.
 *   diet -Os gcc -Os -Wall -o raw2352tocdr2352 raw2352tocdr2352.c;
 *   strip raw2352tocdr2352; ln -s raw2352tocdr2352 cdr2352toraw2352
 * Frank Bergmann <something@tuxad.com>, 3/2006
 */

#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

/* #define BUFLEN 2352 */
#define BUFLEN 16384

/* swap_bytes
 * actually we don't swap bytes but change the order, from
 *    xxxx MSB1 LSB1 MSB2 LSB2 ...    to
 *    LSB1 MSB1 LSB2 MSB2 LSB3 ...
 * *very fast*
 */
void swap_bytes(char *buf, int bytes) {
  register char *p;
  register char *q;
  p = buf;
  q = p+bytes;
  for(;;) {
    *p = p[2]; p += 2; if (p>=q) break;
    *p = p[2]; p += 2; if (p>=q) break;
    *p = p[2]; p += 2; if (p>=q) break;
    *p = p[2]; p += 2; if (p>=q) break;
    /* b = *p; *p = p[1]; ++p; *p = b; ++p; if (p>=q) break; */
  }
}

int main() {
  char buf[BUFLEN+2];
  register ssize_t len;
  register char *p, *q;
  register int raw;
  
  raw = BUFLEN;
  p = buf;
  q = p+1;
  for(;;) {
    len = read(0,q,raw); if (len<1) break; swap_bytes(p, len); write(1,p,len);
    len = read(0,q,raw); if (len<1) break; swap_bytes(p, len); write(1,p,len);
    len = read(0,q,raw); if (len<1) break; swap_bytes(p, len); write(1,p,len);
    len = read(0,q,raw); if (len<1) break; swap_bytes(p, len); write(1,p,len);
    /* len = write(1,p,raw); if (len<1) break;*/
  }
  _exit(0);
}
